import cloneDeep from 'lodash/cloneDeep'
export type Obj = { [key: string]: any }
export type ArrayObj = Array<Obj>
export type rowsSelection = {
  isSelected: boolean
  selectedRows?: ArrayObj
  limitMax?: number
  onClear?: () => void
  setSelectedRows?: (val: ArrayObj) => void
}

export type ColumnProps = Obj & {
  isCreateUser?: boolean
  isMoreVal?: string[]
  isTimestampMore?: boolean
  timestampQtable?: boolean
  noQtable?: boolean
  disableQtable?: boolean
  ellipsisQtable?: boolean
  hideInSetting?: boolean
  sortSubscript?: number
};

export const AddListTreeId = (attr: ArrayObj) => {
  attr.map(v => {
    v.tree__id = Number(Math.random().toString().substr(3, 10) + Date.now()).toString(36)
  })
  return [...attr]
}

export const ArraySort = (attr: any[], name: string): any[] => {
  const _attr = [...attr]
  _attr.sort((a, b) => {
    return a[name] - b[name]
  })
  return _attr
}

export function SetTableColumnsDate<T>(
  data: T[],
  type: string,
  params: {
    [key in string]: any
  }
): T[] {
  const { columns, original_columns = [], fixedType = '', sortType = '' } = cloneDeep(params)
  const current_columns = [...columns]
  let return_columns: T[] = []
  let leftList: T[] = []
  let rightList: T[] = []
  let list: T[] = []
  let sort_columns: T[] = []

  switch (type) {
    case 'reset':
      original_columns.map((v: any, k: number) => (v.sortSubscript = k))
      return_columns = [...original_columns]
      break
    case 'select':
      current_columns.map(v => data.some(m => m === v.tree__id && !v.hideInSetting) ? (v.disableQtable = false) : '')
      return_columns = [...current_columns]
      break
    case 'del':
      current_columns.map(v => data.some(m => m === v.tree__id && !v.hideInSetting) ? (v.disableQtable = true) : '')
      return_columns = [...current_columns]
      break
    case 'fixed':
      current_columns.map(v => {
        if (v.tree__id === data[0]) {
          v.fixed = fixedType
          v.disableQtable = false
        }
        if (v.fixed === 'left') {
          leftList.push(v)
        } else if (v.fixed === 'right') {
          rightList.push(v)
        } else {
          delete v.fixed
          list.push(v)
        }
      })
      return_columns = [...leftList, ...ArraySort(list, 'sortSubscript'), ...rightList]
      break
    case 'sort':
      current_columns.map(v => {
        if (v.fixed === 'left') {
          leftList.push(v)
        } else if (v.fixed === 'right') {
          rightList.push(v)
        } else {
          list.push(v)
        }
      })
      if (sortType === 'left') {
        leftList = [...data]
      } else if (sortType === 'right') {
        rightList = [...data]
      } else {
        list = [...data]
      }
      sort_columns = [...leftList, ...list, ...rightList]
      sort_columns.map((v: Obj, k: number) => (v.sortSubscript = k))
      return_columns = [...sort_columns]
      break
  }
  return return_columns
}
