import AProSetting from './components/AProSetting/index.js'
import AProTable from './components/AProTable/index'
import AProSearch from './components/AProSearch/index'
import AProSku from './components/AProSku/index.js'
import AUploadFile from './components/AUploadFile/index.js'
import AUpload from './components/AUpload/index.js'
import AVideo from './components/AVideo/index.js'
import ACropper from './components/ACropper/index.js'
import AProSelect from './components/AProSelect/index.js'
import AProInput from './components/AProInput/index.js'
import APagination from './components/APagination/index'

const components = [
  AProSetting,
  AProTable,
  AProSearch,
  AProSku,
  AUploadFile,
  AUpload,
  AVideo,
  ACropper,
  AProSelect,
  AProInput,
  APagination
]

const install = function(Vue: any) {
  components.forEach((component: { [key: string]: any }) => {
    Vue.component(component.name, component)
  })
}

if (typeof window !== 'undefined' && window.Vue) {
  install(window.Vue)
}

export default {
  install,
    AProSetting,
  AProTable,
  AProSearch,
  AProSku,
  AUploadFile,
  AUpload,
  AVideo,
  ACropper,
  AProSelect,
  AProInput,
  APagination
}
