import Vue, { PluginObject } from 'vue'
import { ElementUIComponent } from './component'

import { ELAProTable } from './aprotable'
import { ELAProSearch } from './aprosearch'
import { ELAProSku } from './aprosku'
import { ELAUploadFile } from './auploadfile'
import { ELAUpload } from './aupload'
import { ELAVideo } from './avideo'
import { ELACropper } from './acropper'
import { ELAProSelect } from './aproselect'
import { ELAProInput } from './aproinput'

export interface InstallationOptions {
  locale: any,
  i18n: any,
  size: string
}

/**
 * Install all element-ui components into Vue.
 * Please do not invoke this method directly.
 * Call `Vue.use(acomponent)` to install.
 */
export function install (vue: typeof Vue, options: InstallationOptions): void

/** ElementUI component common definition */
export type Component = ElementUIComponent

/** Popconfirm Component */
export class AProSearch extends ELAProSearch {}
export class AProTable extends ELAProTable {}
export class AProSku extends ELAProSku {}
export class AUploadFile extends ELAUploadFile {}
export class AUpload extends ELAUpload {}
export class AVideo extends ELAVideo {}
export class ACropper extends ELACropper {}
export class AProSelect extends ELAProSelect {}
export class AProInput extends ELAProInput {}
